using System.Text.Json.Serialization;

namespace Adaptation.FileHandlers.json.WIQL;

internal class SortColumn
{

    [JsonConstructor]
    public SortColumn(
        Field field,
        bool descending
    )
    {
        Field = field;
        Descending = descending;
    }

    [JsonPropertyName("field")] public Field Field { get; }
    [JsonPropertyName("descending")] public bool Descending { get; }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(SortColumn))]
internal partial class SortColumnSourceGenerationContext : JsonSerializerContext
{
}