using System;
using System.Text.Json.Serialization;

namespace Adaptation.FileHandlers.json.WorkItems;

internal class Fields
{

#nullable enable

    [JsonConstructor]
    public Fields(float? customRRminusOE,
                  CustomRequester? customRequester,
                  float? customWSJF,
                  DateTime microsoftVSTSCommonActivatedDate,
                  float? microsoftVSTSCommonBusinessValue,
                  DateTime microsoftVSTSCommonClosedDate,
                  int microsoftVSTSCommonPriority,
                  DateTime microsoftVSTSCommonResolvedDate,
                  DateTime microsoftVSTSCommonStateChangeDate,
                  float? microsoftVSTSCommonTimeCriticality,
                  float? microsoftVSTSSchedulingEffort,
                  float? microsoftVSTSSchedulingRemainingWork,
                  DateTime microsoftVSTSSchedulingStartDate,
                  float? microsoftVSTSSchedulingStoryPoints,
                  DateTime microsoftVSTSSchedulingTargetDate,
                  string systemAreaPath,
                  SystemAssignedTo systemAssignedTo,
                  SystemChangedBy systemChangedBy,
                  DateTime systemChangedDate,
                  int systemCommentCount,
                  SystemCreatedBy systemCreatedBy,
                  DateTime systemCreatedDate,
                  string systemDescription,
                  string systemHistory,
                  string systemIterationPath,
                  int systemParent,
                  string systemReason,
                  string systemState,
                  string systemTags,
                  string systemTeamProject,
                  string systemTitle,
                  string systemWorkItemType)
    {
        CustomRRminusOE = customRRminusOE;
        CustomRequester = customRequester;
        CustomWSJF = customWSJF;
        MicrosoftVSTSCommonActivatedDate = microsoftVSTSCommonActivatedDate;
        MicrosoftVSTSCommonBusinessValue = microsoftVSTSCommonBusinessValue;
        MicrosoftVSTSCommonClosedDate = microsoftVSTSCommonClosedDate;
        MicrosoftVSTSCommonPriority = microsoftVSTSCommonPriority;
        MicrosoftVSTSCommonResolvedDate = microsoftVSTSCommonResolvedDate;
        MicrosoftVSTSCommonStateChangeDate = microsoftVSTSCommonStateChangeDate;
        MicrosoftVSTSCommonTimeCriticality = microsoftVSTSCommonTimeCriticality;
        MicrosoftVSTSSchedulingEffort = microsoftVSTSSchedulingEffort;
        MicrosoftVSTSSchedulingRemainingWork = microsoftVSTSSchedulingRemainingWork;
        MicrosoftVSTSSchedulingStartDate = microsoftVSTSSchedulingStartDate;
        MicrosoftVSTSSchedulingStoryPoints = microsoftVSTSSchedulingStoryPoints;
        MicrosoftVSTSSchedulingTargetDate = microsoftVSTSSchedulingTargetDate;
        SystemAreaPath = systemAreaPath;
        SystemAssignedTo = systemAssignedTo;
        SystemChangedBy = systemChangedBy;
        SystemChangedDate = systemChangedDate;
        SystemCommentCount = systemCommentCount;
        SystemCreatedBy = systemCreatedBy;
        SystemCreatedDate = systemCreatedDate;
        SystemDescription = systemDescription;
        SystemHistory = systemHistory;
        SystemIterationPath = systemIterationPath;
        SystemParent = systemParent;
        SystemReason = systemReason;
        SystemState = systemState;
        SystemTags = systemTags;
        SystemTeamProject = systemTeamProject;
        SystemTitle = systemTitle;
        SystemWorkItemType = systemWorkItemType;
    }

    [JsonPropertyName("Custom.RRminusOE")] public float? CustomRRminusOE { get; }
    [JsonPropertyName("Custom.Requester")] public CustomRequester? CustomRequester { get; }
    [JsonPropertyName("Custom.WSJF")] public float? CustomWSJF { get; }
    [JsonPropertyName("Microsoft.VSTS.Common.ActivatedDate")] public DateTime MicrosoftVSTSCommonActivatedDate { get; }
    [JsonPropertyName("Microsoft.VSTS.Common.BusinessValue")] public float? MicrosoftVSTSCommonBusinessValue { get; }
    [JsonPropertyName("Microsoft.VSTS.Common.ClosedDate")] public DateTime MicrosoftVSTSCommonClosedDate { get; }
    [JsonPropertyName("Microsoft.VSTS.Common.Priority")] public int MicrosoftVSTSCommonPriority { get; }
    [JsonPropertyName("Microsoft.VSTS.Common.ResolvedDate")] public DateTime MicrosoftVSTSCommonResolvedDate { get; }
    [JsonPropertyName("Microsoft.VSTS.Common.StateChangeDate")] public DateTime MicrosoftVSTSCommonStateChangeDate { get; }
    [JsonPropertyName("Microsoft.VSTS.Common.TimeCriticality")] public float? MicrosoftVSTSCommonTimeCriticality { get; }
    [JsonPropertyName("Microsoft.VSTS.Scheduling.Effort")] public float? MicrosoftVSTSSchedulingEffort { get; }
    [JsonPropertyName("Microsoft.VSTS.Scheduling.RemainingWork")] public float? MicrosoftVSTSSchedulingRemainingWork { get; }
    [JsonPropertyName("Microsoft.VSTS.Scheduling.StartDate")] public DateTime MicrosoftVSTSSchedulingStartDate { get; }
    [JsonPropertyName("Microsoft.VSTS.Scheduling.StoryPoints")] public float? MicrosoftVSTSSchedulingStoryPoints { get; }
    [JsonPropertyName("Microsoft.VSTS.Scheduling.TargetDate")] public DateTime MicrosoftVSTSSchedulingTargetDate { get; }
    [JsonPropertyName("System.AreaPath")] public string SystemAreaPath { get; }
    [JsonPropertyName("System.AssignedTo")] public SystemAssignedTo? SystemAssignedTo { get; }
    [JsonPropertyName("System.ChangedBy")] public SystemChangedBy SystemChangedBy { get; }
    [JsonPropertyName("System.ChangedDate")] public DateTime SystemChangedDate { get; }
    [JsonPropertyName("System.CommentCount")] public int SystemCommentCount { get; }
    [JsonPropertyName("System.CreatedBy")] public SystemCreatedBy SystemCreatedBy { get; }
    [JsonPropertyName("System.CreatedDate")] public DateTime SystemCreatedDate { get; }
    [JsonPropertyName("System.Description")] public string SystemDescription { get; }
    [JsonPropertyName("System.History")] public string SystemHistory { get; }
    [JsonPropertyName("System.IterationPath")] public string SystemIterationPath { get; }
    [JsonPropertyName("System.Parent")] public int SystemParent { get; }
    [JsonPropertyName("System.Reason")] public string SystemReason { get; }
    [JsonPropertyName("System.State")] public string SystemState { get; }
    [JsonPropertyName("System.Tags")] public string SystemTags { get; }
    [JsonPropertyName("System.TeamProject")] public string SystemTeamProject { get; }
    [JsonPropertyName("System.Title")] public string SystemTitle { get; }
    [JsonPropertyName("System.WorkItemType")] public string SystemWorkItemType { get; }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(Fields))]
internal partial class FieldsSourceGenerationContext : JsonSerializerContext
{
}