using System.Text.Json.Serialization;

namespace Adaptation.FileHandlers.json.WorkItems;

internal class SystemCreatedBy
{

    [JsonConstructor]
    public SystemCreatedBy(
        string displayName,
        string url,
        Links links,
        string id,
        string uniqueName,
        string imageUrl,
        string descriptor
    )
    {
        DisplayName = displayName;
        Url = url;
        Links = links;
        Id = id;
        UniqueName = uniqueName;
        ImageUrl = imageUrl;
        Descriptor = descriptor;
    }

    [JsonPropertyName("_links")] public Links Links { get; }
    [JsonPropertyName("descriptor")] public string Descriptor { get; }
    [JsonPropertyName("displayName")] public string DisplayName { get; }
    [JsonPropertyName("id")] public string Id { get; }
    [JsonPropertyName("imageUrl")] public string ImageUrl { get; }
    [JsonPropertyName("uniqueName")] public string UniqueName { get; }
    [JsonPropertyName("url")] public string Url { get; }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(SystemCreatedBy))]
internal partial class SystemCreatedBySourceGenerationContext : JsonSerializerContext
{
}